<?php

/**
 * Created by PhpStorm.
 * User: Alessandro
 * Date: 08/03/16
 * Time: 17:08
 */
class TmbCvettaFeed extends TmbCvettaCatalogue
{
	private $limit = null;

	/* Method to add adata to XML ceate / append */
	public $method = null; // data_create
	public $file_name;
	const DATA_APPEND = 1;
	const DATA_CREATE = 2;

	public function __construct($id_shop = null, $id_lang = null)
	{
		parent::__construct($id_shop, $id_lang);
	}

	public function getFile()
	{
		$file = 'xml/*_shop'.$this->context->shop->id.'_lang'.$this->context->language->id.'.xml';
		$file_list = glob($file);
		$file_list = array_reverse($file_list);

		if (!empty($file_list))
		{
			$file = $file_list[0];
			$this->method = self::DATA_APPEND;
			$this->file_name = basename($file);
		}
		else
		{
			$this->method = self::DATA_CREATE;
			$this->file_name = date('Ymd_Hi').'_shop'.$this->context->shop->id.'_lang'.$this->context->language->id.'.xml';
		}
	}

	public function closeFile(){

        $file = 'xml/'.$this->file_name;
        $fh = file_get_contents($file);

        $eof=substr($fh, -6);
        if($eof != "</add>")
            file_put_contents(__DIR__."/../feed/xml/".$this->file_name,'</add>',FILE_APPEND);
    }

	public function generateFeed()
	{
		$items = $this->getItems();
        $this->getFile();
        $start = Tools::getValue('start', "false");
		if (empty($items)) {
            $this->closeFile();
            return false;
        }

/*
		if ($this->method == self::DATA_APPEND)
		{
            $current_xml = simplexml_load_file('xml/' . $this->file_name, "SimpleXMLElement", LIBXML_COMPACT | LIBXML_PARSEHUGE );
            $xml = new SimpleXMLElementExtended('<?xml version="1.0" encoding="utf-8" ?><add></add>');

		}
		elseif ($this->method == self::DATA_CREATE)
		{
		}*/
        $xml = new SimpleXMLElementExtended('<?xml version="1.0" encoding="utf-8" ?><add></add>');
		if($start == "true")
            file_put_contents(__DIR__ . "/../feed/xml/" . $this->file_name, '<?xml version="1.0" encoding="utf-8"?><add>');

		foreach ($items as $item)
		{
			$id_group = $this->id_default_group;

			$doc = $xml->addChild('doc');
			$doc->addChildWithCDATA('field', $item['id_product'])->addAttribute('name', 'sku');

			$references = explode(';', $item['reference']);
			if (!empty($references))
				foreach ($references as $reference)
					$doc->addChildWithCDATA('field', $this->safeOutput($reference))->addAttribute('name', 'reference');

			if (!empty($item['categories']))
				foreach ($item['categories'] as $category)
					$doc->addChildWithCDATA('field', $this->safeOutput($category))->addAttribute('name', 'categories');

			if (!empty($item['attributes']))
				foreach ($item['attributes'] as $attribute_group => $attributes)
					foreach ($attributes as $attribute)
						$doc->addChildWithCDATA('field', $this->safeOutput($attribute))->addAttribute('name', $this->normalizeFieldName($attribute_group));

			if (!empty($item['features']))
				foreach ($item['features'] as $feature => $feature_values)
					foreach ($feature_values as $feature_value)
						$doc->addChildWithCDATA('field', $this->safeOutput($feature_value))->addAttribute('name', $this->normalizeFieldName($feature));

			$doc->addChildWithCDATA('field', $this->safeOutput($item['name']))->addAttribute('name', 'name');

			if ($item['manufacturer'] != "")
				$doc->addChildWithCDATA('field', $this->safeOutput($item['manufacturer']))->addAttribute('name', 'manufacturer');

			if ($item['supplier'] != "")
				$doc->addChildWithCDATA('field', $this->safeOutput($item['supplier']))->addAttribute('name', 'supplier');

			$base_price = $this->getRetailPrice($item['id_product']);
			$final_price = $this->getFinalPrice($item['id_product']);

			if ($base_price != "")
				$doc->addChildWithCDATA('field', $base_price)->addAttribute('name', 'price');
			
			if ($final_price != "" && $final_price < $base_price)
				$doc->addChildWithCDATA('field', $final_price)->addAttribute('name', 'special_price');

			$doc->addChildWithCDATA('field', $item['link'])->addAttribute('name', 'url_key');
			
			if (empty($item['image_link'])) {
				$link = new Link();
				$item['image_link'] =  $link->getImageLink($item['name'], Language::getIsoById($this->context->language->id).'-default-home_default');
			}
			
			$doc->addChildWithCDATA('field', $item['image_link'])->addAttribute('name', 'image');

			$description = $this->safeOutput(strip_tags($item['description']));
			$description = str_replace(array("\r\n", "\n", "\r"), ' ', $description);
			if ($description != "")
				$doc->addChildWithCDATA('field', $description)->addAttribute('name', 'description');
			
			$description_short = $this->safeOutput(strip_tags($item['description_short']));
			$description_short = str_replace(array("\r\n", "\n", "\r"), ' ', $description_short);
			if ($description_short != "")
				$doc->addChildWithCDATA('field', $description_short)->addAttribute('name', 'description_short');
			
			$doc->addChildWithCDATA('field', $item['quantity'])->addAttribute('name', 'qty');
			$doc->addChildWithCDATA('field', ((int)$item['quantity'] > 0 ? 1 : 0))->addAttribute('name', 'is_in_stock');
			$doc->addChildWithCDATA('field', $item['active'])->addAttribute('name', 'active');
            file_put_contents(__DIR__."/../feed/xml/".$this->file_name,$doc->asXML(),FILE_APPEND);
		}

        //$xml->saveXML('xml/'.$this->file_name);
		return true;
	}

	public function normalizeFieldName($str)
	{
		$str = (string)$str;

		if ($str == '')
			return '';

		$has_mb_strtolower = function_exists('mb_strtolower');

		$return_str = trim($str);

		if ($has_mb_strtolower)
			$return_str = mb_strtolower($return_str, 'utf-8');

		$return_str = Tools::replaceAccentedChars($return_str);

		// Remove all non-whitelist chars.
		$return_str = preg_replace("/[^a-zA-Z0-9\s\'\:\/\[\]\-\_]/", "", $return_str);
		$return_str = preg_replace('/[\s\'\:\/\[\]\-]+/', ' ', $return_str);
		$return_str = str_replace(array(' ', '/'), '_', $return_str);

		// If it was not possible to lowercase the string with mb_strtolower, we do it after the transformations.
		// This way we lose fewer special chars.
		if (!$has_mb_strtolower)
			$return_str = Tools::strtolower($return_str);

		return $return_str;
	}

	public function deleteFeed()
	{
		$this->getFile();
		if (file_exists('xml/'.$this->file_name))
			if (unlink('xml/'.$this->file_name))
				Db::getInstance()->execute("DELETE FROM "._DB_PREFIX_."tmbcvetta_feed{$this->context->shop->id} WHERE id_lang = {$this->context->language->id};");
	}

	protected function output(SimpleXMLElement $xml)
	{
		if ($this->debug)
		{
			header('Content-type: text/xml');
			echo $xml->asXML();
		}
		else
		{
			// Usa il DOMDocument per formattare l'XML
			$dom = new DOMDocument("1.0");
			$dom->preserveWhiteSpace = false;
			$dom->formatOutput = true;
			$dom->loadXML($xml->asXML());
			$dom->save('xml/'.$this->file_name);
			return true;
		}
	}

	public function getItems()
	{
		$id = $this->context->shop->id;
		$id_lang = $this->context->language->id;

		$items = $this->getItemsList();

		$list = array();
		$link = new Link();

		foreach ($items as &$item)
		{
			$product = new Product($item['id_product']);

			// Get name, description, description_short
			$item['name'] = $product->name[$id_lang];
			$item['description'] = $product->description[$id_lang];
			$item['description_short'] = $product->description_short[$id_lang];

			$category_default = null;
			// Replace categories id with categories names
			if (!empty($item['categories']))
			{
				$categories = explode(';', $item['categories']);
				if (!empty($item['categories']) && (int)$item['categories'][0] > 0)
				{
					$item['categories'] = array();
					foreach ($categories as $id_category)
					{
						$category = new Category($id_category);
						$category_name = $category->getName($id_lang);
						$item['categories'][$id_category] = $category_name;
						if ((int)$id_category == (int)$item['id_category_default'])
							$category_default = $category_name;
					}
				}
			}

			// Replace attributes id with attributes names
			if (!empty($item['attributes']))
			{
				$attributes = explode(';', $item['attributes']);
				if (!empty($item['attributes']) && (int)$item['attributes'][0] > 0)
				{
					$item['attributes'] = array();
					foreach ($attributes as $id_attribute)
					{
						$attribute = new Attribute($id_attribute);
						$attribute_name = $attribute->name[$id_lang];

						$attributes_group = array();

						if (isset($this->params['id_attributes_group']))
							$attributes_group = json_decode($this->params['id_attributes_group'], true);

						if (!empty($attributes_group))
							if (!in_array($attribute->id_attribute_group, $attributes_group))
								continue;

						$attribute_group = new AttributeGroup($attribute->id_attribute_group);
						$attribute_group_name = $attribute_group->public_name[$id_lang];
						$item['attributes'][$attribute_group_name][$id_attribute] = $attribute_name;
					}
				}
			}

			
			// Replace features id with features names
			if (!empty($item['features']))
			{
				$features = explode(';', $item['features']);
				if (!empty($item['features']) && (int)$item['features'][0] > 0)
				{
					$item['features'] = array();
					foreach ($features as $id_feature_values)
					{
						$feature_value = new FeatureValue($id_feature_values);
						$feature_value_name = $feature_value->value[$id_lang];

						$features_group = array();

						if (isset($this->params['id_features']))
							$features_group = json_decode($this->params['id_features'], true);

						if (!empty($features_group))
							if (!in_array($feature_value->id_feature, $features_group))
								continue;

						$feature = new Feature($feature_value->id_feature);
						$feature_name = $feature->name[$id_lang];
						$item['features'][$feature_name][$id_feature_values] = $feature_value_name;
					}
				}
			}

			$item['link'] = $link->getProductLink($product, $product->link_rewrite[$id_lang], $category_default, null, $id_lang, $id);
			$list[] = $item;

			@$this->signItem($item);
		}
		
		return $list;
	}

	public function getItemsList()
	{
		$str_restrictions = $this->getRestrictionProducts();
		$str_categories = $this->getSelectedCategories();

		$sql = "SELECT c.* FROM "._DB_PREFIX_."tmbcvetta_items{$this->context->shop->id} c "
		    ."LEFT JOIN "._DB_PREFIX_."tmbcvetta_feed{$this->context->shop->id} f ON (f.id_product = c.id_product AND f.id_lang = {$this->context->language->id}) "
		    ." WHERE 1"
		    .$str_restrictions
		    .$str_categories
		    .' AND f.id_product IS NULL '
		    .(!is_null($this->limit) ? " LIMIT ".$this->limit : "");
			
		return Db::getInstance()->executeS($sql);
	}

	public function signItem($item)
	{
		$data = array();
		$data['id_product'] = (int)$item['id_product'];
		$data['id_lang'] = (int)$this->context->language->id;
		return Db::getInstance()->insert("tmbcvetta_feed{$this->context->shop->id}", $data);
	}

	protected function safeOutput($string)
	{
		return preg_replace('/[^[:print:]]/', '', htmlspecialchars($string));
	}

	public function sendFeed()
	{

		$file = 'xml/'.$this->file_name;
		$remote_file = 'shop'.$this->context->shop->id.'_lang'.$this->context->language->id.'.xml';

        $fh = file_get_contents($file);

        $eof=substr($fh, -6);
        if($eof != "</add>")
            $this->closeFile();

        $ftp_server = 'cvetta.ittweb.net';
		$conn_id = ftp_connect($ftp_server);

		$login_result = ftp_login($conn_id, Configuration::get('TMBCVETTA_USERNAME'), Configuration::get('TMBCVETTA_PASSWORD'));	
		ftp_pasv($conn_id, true);				

		$res = ($login_result && ftp_put($conn_id, $remote_file, $file, FTP_ASCII) ? true : false);

		ftp_close($conn_id);

		return $res;
	}

	public function setLimit($limit)
	{
		$this->limit = $limit;
	}

}

Class SimpleXMLElementExtended extends SimpleXMLElement
{

	/**
	 * Adds a child with $value inside CDATA
	 * @param unknown $name
	 * @param unknown $value
	 */
	public function addChildWithCDATA($name, $value = NULL)
	{
		$new_child = $this->addChild($name);

		if ($new_child !== NULL)
		{
			$node = dom_import_simplexml($new_child);
			$no = $node->ownerDocument;
			$node->appendChild($no->createCDATASection(trim($value)));
		}

		return $new_child;
	}

	public function appendXML($append)
	{
		if ($append)
		{
			if (strlen(trim((string)$append)) == 0)
			{
				$xml = $this->addChild($append->getName());
			}
			else
			{
				$xml = $this->addChild($append->getName(), (string)$append);
			}

			foreach ($append->children() as $child)
			{
				$xml->appendXML($child);
			}

			foreach ($append->attributes() as $n => $v)
			{
				$xml->addAttribute($n, $v);
			}
		}
	}

}
